// Variable to store session number for printing out the grade for the session
let sessionNumber = 4;

require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;
const { http, https } = require('follow-redirects');

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

/*sends request to url to check status*/
const requestPromise = ((urlOptions, data) => {
	return new Promise((resolve, reject) => {
	  let url = new URL(urlOptions)
	  if(url.origin === "https://www.linkedin.com"){
		url = url.origin;
	  } else {
		url = url.href
	  }
	  const req = https.request(url,
		(res) => {
		  let body = '';
		  res.on('data', (chunk) => (body += chunk.toString()));
		  res.on('end', () => {
			if (res.statusCode >= 200 && res.statusCode <= 299) {
			  resolve(res.statusCode);
			} else {
			  reject(res.statusCode);
			}
		  });
		});
	  req.end();
	});
  });

const linkCheck = require('link-check');



if(!jsonData.gradedTest.s04){

	try {

		//Automated Grading Integration
		// Variable to store passing unit test scores for the session
		let passingTests = 0;
		// Variable to store total number of session unit tests
		let totalTests = 0;

		if (!fs.existsSync('./sessions/frontend/s04/activity/index.html')) {
			throw new Error('File not found');
		}

		describe(`s0${sessionNumber}`, function() {
			

			this.timeout(30000);
			
			let driver;
			let vars;
		
			let internalCssTestPassed = false;
		
			function parsePixels(value) {
				return parseFloat(value.replace('px', ''));
			}

			let startTime;

			before(async function() {
			  startTime = performance.now();
			  // Any setup code you need to run before the tests start
			  driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
			});

			const options = new firefox.Options();
			options.headless();

			options.setPreference('browser.download.manager.showWhenStarting', false);
			options.setPreference('browser.download.manager.useWindow', false);

			beforeEach(async function() {

			  totalTests += 1;
			  vars = {}
			})

			afterEach(function(){

				if(this.currentTest.state === "passed"){
					passingTests += 1;
				}

				process.removeAllListeners(); 

			})
	
		
			it('No link is broken', async function() {

				const filePath = path.join(__dirname, '..','sessions','frontend','s04','activity','index.html');
				const url = `file://${filePath}`;
				await driver.get(url);
				
				{
				  /*get every link*/
				  const elements = await driver.findElements(By.css("a"))
				  let urlArr = [];
				  let broken = 0;
		  
				  /*loop over every url from every link*/
				  for(let i = 0; i < elements.length; i++){
					  let url = await elements[i].getAttribute("href")
					  urlArr.push(url);
				  }
		  
				  /*navigate to each page and check each links*/
				  for(let i = 0; i < urlArr.length; i++){
					await driver.navigate().to(urlArr[i]);
					const pageElements = await driver.findElements(By.css("a"))
					for(let i = 0; i < pageElements.length; i++){
						let urlPage = await pageElements[i].getAttribute("href")
					   {
							linkCheck(urlPage, function (err, result) {
								if (err) {
									console.error(err);
									return;
								} else if (result.status === "dead"){
									broken += 1;
								}
								
							});
					   }
					}
				  }
				  /*assert no broken link found*/
				  expect(broken).to.equal(0,"One or more links are broken.");
				}
			})

			it('No img is broken', async function() {
				const filePath = path.join(__dirname, '..','sessions','frontend','s04','activity','index.html');
				const url = `file://${filePath}`;
				await driver.get(url);

				{
				  const elements = await driver.findElements(By.css("a"))
				  let urlArr = [];
				  let broken = 0;
		  
				  for(let i = 0; i < elements.length; i++){
					  let url = await elements[i].getAttribute("href")
					  urlArr.push(url);
				  }
		  
				  /*navigate to each page and check each links*/
				  for(let i = 0; i < urlArr.length; i++){
					await driver.navigate().to(urlArr[i]);
					const pageElements = await driver.findElements(By.css("img"))
					for(let i = 0; i < pageElements.length; i++){
						let urlPage = await pageElements[i].getAttribute("src")
					   {
								linkCheck(urlPage, function (err, result) {
									if (err) {
										broken += 1;
									} else if (result.status === "dead"){
										broken += 1;
									}
									
								});
					   }
					}
				  }
		  
				  /*assert no broken link found*/
				  expect(broken).to.equal(0,"One or more image src links are broken.");
				}
			  })


		
		
		  after(async function () {

			// // Wait for all promises to settle before calling driver.quit()
			// await Promise.all(globalThis.PromiseManager.promises);


			const endTime = performance.now();
			const totalTime = (endTime - startTime) / 1000; // Convert to seconds
			console.log(`Total time taken: ${totalTime} seconds`);
  
			global.gradesObject["s04"] = {
			  grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
			  score: `${passingTests}/${totalTests}`
			}
		
			jsonData.gradedTest.s04 = true;
		    await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));

			// await driver.close()
			await driver.quit(); 
		  });
		
		})	
	} catch (err) {
		if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
		  console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
		} else {
		  console.log(err)
		}
	  }
} else {
	console.log("S04 - Tested");
}

